//var session = lightdm.default_session;
var messageTimeout;
var messagesVisible;
var waitingForAuth;

var users = {};


function show_prompt(text) {
	// when we get the password PROMPT signal back from pam, then send the password

        // c implementation
	// lightdm.provide_secret($('#password').text());
        // py implementation
        window.location = "password:"+$('#password').text();

	waitingForAuth=true;
	$('#username-pin-instructions').hide();
        $('.messages').hide();
	$('#spinner').spin();
	$('#username').attr('contentEditable',false);
	$('#password').attr('contentEditable',false);
}

function show_gx_label(gx_label) {
       $('#gx-label-content').text(gx_label);
}

function show_user_buttons() {
	$('#special-user-wrapper').css("visibility", "visible");
}
function show_pacrez_status(color,message) {
	var newColor;
       $('#pacrez-message').html(message);
       //$('#pacrez-status').show()
       $('#pacrez-status').css("visibility", "visible");
       //$('#pacrez-status').addClass("pacrez-background-"+color);
       //$('#pacrez-status').css('background', color);

switch (color)
{
case "green":
  newColor="lime"
  newColor="#98FB98"
  newColor="#80FF80"
  newColor="#00CC00"
  break;
case "red":
  newColor="pink"
  newColor="#FF8080"
  break;
case "orange":
  newColor="orange"
  newColor="#FFC080"
  break;
case "yellow":
  newColor="yellow"
  newColor="#FFFF80"
  break;
case "white":
  newColor="white"
  break;
case "grey":
  newColor="grey"
  break;
default:
  newColor="grey"
}
//$('#pacrez-status').css('border-color', newColor);
$('#pacrez-status').css('background', newColor);

}

/*
function fade_out_messages() {
	//$('.messages').fadeOut(5000);
	messagesVisible=false;
	$('.messages').fadeTo(5000,0);
}
*/

function hide_messages(fade) {

	if ( messagesVisible == true ) {
		messagesVisible=false;
		$('.messages').fadeTo(fade,0,show_instructions)
	}
}

function show_instructions() {
	$('#username-pin-instructions').fadeIn("fast");
}

function display_message(text,messageLine) {
	var myID='#messages'+messageLine;
	//$(myID).hide();
	$(myID).html(text);
	//$(myID).fadeIn('slow');
	//$('.messages').fadeIn("slow");
        //$('.messages').css('opacity', 0).css({visibility: "visible"}).fadeTo("slow",1);
        messagesVisible=true;
        $('.messages').fadeTo("fast",1);
	$('#username-pin-instructions').hide();
	clearTimeout(messageTimeout);
	messageTimeout=setTimeout("hide_messages(5000)",10000)
}

// messages generated from within this greeter
function show_message_internal(text) {
        var messageLine="1";
	display_message(text,messageLine);
}

// pam messages
function show_message(text) {
        var messageLine="2";
	//display_message(text+"<br>hey",messageLine);
	display_message(text,messageLine);
}


// py implementation
function authentication_failed() {
               $('#spinner').spin(false);
	waitingForAuth=false;
	$('#username').attr('contentEditable',true);
	$('#password').attr('contentEditable',true);
		show_message_internal("Authentication Failed");
		$('#username').text('');
		$('#password').text('');
		$('#username').focus();
}


/* 
// c implementation
function authentication_complete() {
	$('#spinner').spin(false);
	if (lightdm.is_authenticated) {
		lightdm.login(lightdm.authentication_user, session);
	} else {
		show_message_internal("Authentication Failed 1");
		//$('#password').addClass('error');
		//$('#username').fadeOut("slow");
		//$('#password').fadeOut("slow");
		$('#username').text('');
		$('#password').text('');
		$('#username').focus();
	}

}
*/

function mouse_trap() {
	window.onmousemove = mouse_moved();
}
function mouse_moved() {
       alert('mouse moved');
       window.onmousemove=null;     
       $('body').css('cursor','default');
}



function get_datetime() {

var d=new Date();
var weekday=new Array(7);
weekday[0]="Sun";
weekday[1]="Mon";
weekday[2]="Tue";
weekday[3]="Wed";
weekday[4]="Thu";
weekday[5]="Fri";
weekday[6]="Sat";

var d=new Date();
var month=new Array();
month[0]="Jan";
month[1]="Feb";
month[2]="Mar";
month[3]="Apr";
month[4]="May";
month[5]="Jun";
month[6]="Jul";
month[7]="Aug";
month[8]="Sep";
month[9]="Oct";
month[10]="Nov";
month[11]="Dec";

var n = month[d.getMonth()];

var n = weekday[d.getDay()];


var minutes = d.getMinutes();
if (minutes < 10) {
	minutes = "0" + minutes;
}
var hours=d.getHours();
var hours12=0;

var ampm="";
if ( hours < 12 ) {
	ampm="AM" ;
	hours12=hours;
} else {
	ampm="PM" ;
	hours12=hours-12;
}
if ( hours12 == 0 ) {
	hours12=12;
}

/*
$('#datetime-content').text(weekday[d.getDay()]+" "+month[d.getMonth()]+" "+d.getDate()+" "+d.getHours()+":"+minutes+":"+d.getSeconds())
*/
$('#datetime-content').text(weekday[d.getDay()]+" "+month[d.getMonth()]+" "+d.getDate()+" "+hours12+":"+minutes+" "+ampm)

}


$(function () {

/* keep focus on username and password fields, clicking anywhere else will bring focus back */
	document.getElementById('username').onblur= function() {

		setTimeout(function() {

			var pelement= document.getElementById('password');
			if ( pelement == pelement.ownerDocument.activeElement ) {
				/*alert("password has focus!")*/
			} else {
				/*alert("password NOT focus!")*/
		       		document.getElementById('username').focus()
				/* would be nice to have cursor return to end of line but methods that
					reset the value and set it again dont work at least in this environment */
			}

		}, 1 )
	}

	document.getElementById('password').onblur= function() {

		setTimeout(function() {

			var pelement= document.getElementById('username');
			if ( pelement == pelement.ownerDocument.activeElement ) {
				/*alert("username has focus!")*/
			} else {
				/*alert("username NOT focus!")*/
		       		document.getElementById('password').focus()
				/* would be nice to have cursor return to end of line but methods that
					reset the value and set it again dont work at least in this environment */
			}

		}, 1 )
	}

/*
	var dt = new DateTime();
	$("#datetime-content").text(dt.formats.pretty.b);
	alert(dt.formats.pretty.b);
*/

	get_datetime()
	setInterval("get_datetime()", 60000);        

	$('#username').focus();
	//$('.messages').hide();
        //$('.messages').css("visibility", "hidden");

	//window.setTimeout(mouse_trap,5000);


	// for passwordless logins, on click start authentication
	$('.special-user-button').click(function () {

                // c implementation
		//lightdm.start_authentication($(this).attr('id'));
                // py implementation
		if ( waitingForAuth == true ) {
			$('#spinner').hide().fadeIn("slow");
		} else {
			//window.location = "username:"+$('.special-user-button').attr('id');
			//window.location = "username:"+$(this).attr('id');
			//window.location="username:"+specialUser1;
			//window.location="username:"+specialUsers[$(this).attr('id')];
		        waitingForAuth=true;
                        $('#username-pin-instructions').hide();
                        $('.messages').hide();
		        $('#spinner').spin();
			if ( $(this).attr('id') == "variableSpecialUser" ) {
				window.location = "username:"+variableSpecialUser;
			} else {
				window.location = "username:"+$(this).attr('id');
			}

		}
	});




	// if they hit enter while in the username field, dont' submit, go to the password field
	$('#username').keydown(function (event) {

                // if they're typing, assume they saw message, get rid of it
		//$('.messages').hide();
		//$('.messages').css("visibility", "hidden");
		//$('.messages').fadeTo("slow",0)
                hide_messages("slow")

        	if (event.keyCode == 13) {
			event.preventDefault();
			$('#password').focus();
		} else if (event.keyCode == 8) {
			// if they're just trying to hit the backspace, let them
			
		} else {
			if ( $('#username').text().length > 30) {
				$('#password').focus();
			}
		}
	});


	$('#password').keydown(function (event) {
		// if they hit enter while in the password field
		if (event.keyCode == 13) {
			// don't have enter creating a newline
			event.preventDefault();
			// start the authentication process by sending the username
                        // c implementation
			// lightdm.start_authentication($('.other-user-login .name').text());
                        // py implementation
                        window.location = "username:"+$('#username').text();
		}  else {
			if ( $('#password').text().length > 30) {
				$('#password').text('')
			}
		}
	});

        $('#ok-button').click(function () {
                // c implementation
		// lightdm.start_authentication($('.other-user-login .name').text());
                // py implementation
		if ( waitingForAuth == true ) {
               		//alert("Authentication already in progress, please wait...")
			$('#spinner').hide().fadeIn("slow");
		} else {

			// if pin is blank direct them to the pin field unless we're already there ( we might want a blank pin at some point )
			if ( ( $('#password').text().length > 0 ) || ( $('#password').is(':focus') )  ) {
				//alert($('#password').text());
				window.location = "username:"+$('#username').text();
			} else {
				//alert('need to focus');
				$('#password').focus();
			}

		}
        });



});


